// Create the IPFS node instance
const IPFS = require('ipfs')
const Graph = require('./')

const node = new IPFS({
  start: false
})

node.on('ready', async () => {
  const graph = new Graph(node.dag)
  const a = {
    some: {
      thing: 'nested'
    }
  }
  const b = {
    lol: 1
  }

  await graph.set(a, 'some/thing/else', b)
  await graph.flush(a)
  const output1 = await graph.get(a, 'some/thing/else')

  const c = {
    lol: 2
  }

  await graph.set(a, 'some/thing/else', c)
  await graph.flush(a)
  const output2 = await graph.get(a, 'some/thing/else')
  console.log(output1)
  console.log(output2)
})
